<% local view, viewlibrary, page_info, session = ... %>
<% require("viewfunctions") %>
<% --[[
	io.write(html.cfe_unpack(view))
--]] %>

<% displaycommandresults({"edituserpermisisons", "editrolepermissions"}, session) %>

<H1><%= html.html_escape(view.label) %></H1>

<H2>User Permissions</H2>
<TABLE>
<TR><TD CLASS='header'>User</TD><TD CLASS='header'>Permissions</TD>
<% for i,user in ipairs(view.value.user) do %>
	<TR><TD><%= html.link{value=page_info.script .. page_info.prefix .. page_info.controller .. "/edituserpermissions?userid=" .. user.id .. "&redir="..page_info.orig_action, label=user.id} %></TD><TD>
	<% for y,allowed in pairs(user.allowed) do
		print(html.html_escape(allowed), "<BR>")
	end %>
	<TD></TR>
<% end %>
</TABLE>

<H2>Role Permissions</H2>
<TABLE>
<TR><TD CLASS='header'>Role</TD><TD CLASS='header'>Permissions</TD>
<% for i,role in ipairs(view.value.role) do %>
	<TR><TD><%= html.link{value=page_info.script .. page_info.prefix .. page_info.controller .. "/editrolepermissions?role=" .. role.id .. "&redir="..page_info.orig_action, label=role.id} %></TD><TD>
	<% for y,allowed in pairs(role.allowed) do
		print(html.html_escape(allowed), "<BR>")
	end %>
	<TD></TR>
<% end %>
</TABLE>
